extern "C" 
{
	#include "LuaLib\lua.h"
	#include "LuaLib\lualib.h"
	#include "LuaLib\lauxlib.h"
}

class LUA_Vector3 
{
private:
    float X;
	float Y;
	float Z;
  public:
	LUA_Vector3()
	{
	}
    LUA_Vector3(float x, float y, float z)
	{
	  X = x;
	  Y = y;
	  Z = z;
	}
	float GetX()
	{
	  return X;
	}
	float GetY()
	{
	  return Y;
	}
	float GetZ()
	{
	  return Z;
	}
	void AssignX(float x)
	{
	  X = x;
	}
	void AssignY(float y)
	{
	  Y = y;
	}
	void AssignZ(float z)
	{
	  Z = z;
	}
  
};

class MyTestLuaClass
{
  static const luaL_reg methods[];
  

  static int RegisterTable(lua_State *L) 
  {
	float x = (float)luaL_checknumber(L, 1);
	float  y = (float)luaL_checknumber(L, 2);
	float z = (float)luaL_checknumber(L, 3);
	LUA_Vector3 *a = new LUA_Vector3(x, y, z);
	lua_boxpointer(L, a);
	luaL_getmetatable(L, "Vector3");
	lua_setmetatable(L, -2);
	return 1;
  }
  static int GetX(lua_State *L)
  {
	LUA_Vector3 *a = GetInstance(L, 1);
	lua_pushnumber(L, a->GetX());
	return 1;
  }
  static int GetY(lua_State *L)
  {
    LUA_Vector3 *a = GetInstance(L, 1);
	lua_pushnumber(L, a->GetY());
	return 1;
  }
  static int GetZ(lua_State *L)
  {
	LUA_Vector3 *a = GetInstance(L, 1);
	lua_pushnumber(L, a->GetZ());
	return 1;
  }

  static int AssignX(lua_State *L)
  {
	LUA_Vector3 *a = GetInstance(L, 1);
	a->AssignX((float)luaL_checknumber(L, 2));
	return 0;
  }
  static int AssignY(lua_State *L)
  {
    LUA_Vector3 *a = GetInstance(L, 1);
	a->AssignY((float)luaL_checknumber(L, 2));
	return 0;
  }
  static int AssignZ(lua_State *L)
  {
	LUA_Vector3 *a = GetInstance(L, 1);
	a->AssignZ((float)luaL_checknumber(L, 2));
	return 0;
  }

static int DeleteInstance(lua_State *L) 
{
     LUA_Vector3  *a = (LUA_Vector3 *)lua_unboxpointer(L, 1);
      delete a;
      return 0;
}
public:
  static void Register(lua_State *L)
  {
	lua_newtable(L);                
	int methodtable = lua_gettop(L);
	luaL_newmetatable(L, "Vector3"); 
	int metatable = lua_gettop(L);

	lua_pushliteral(L, "__metatable");
    lua_pushvalue(L, methodtable);
    lua_settable(L, metatable);

    lua_pushliteral(L, "__index");
    lua_pushvalue(L, methodtable);
    lua_settable(L, metatable);

	lua_pushliteral(L, "__gc");
    lua_pushcfunction(L, DeleteInstance);
    lua_settable(L, metatable);

	lua_pop(L, 1);

	luaL_openlib(L, 0, methods, 0);
    lua_pop(L, 1);  

    lua_register(L, "Vector3", RegisterTable);
  }
  static LUA_Vector3 *GetInstance(lua_State *L, int n)
  {
	luaL_checktype(L, n, LUA_TUSERDATA);
	void *ud = luaL_checkudata(L, n, "Vector3");
	if(!ud) luaL_typerror(L, n, "Vector3");
	return *(LUA_Vector3**)ud;
  }
};


